using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Azbest
{
    public class TileDrawer
    {
        public static void DrawTile(IDrawableSquare tile, Graphics graph, int posX, int posY, int size)
        {
            Point leftUp = new Point(posX, posY);
            Point rightUp = new Point(posX + size, posY);
            Point rightDown = new Point(posX + size, posY + size);
            Point leftDown = new Point(posX, posY + size);
            Point middle = new Point(posX + (size / 2), posY + (size / 2));

            graph.FillPolygon(GameManager.Instance.GetBrushForColor(tile.LeftColor), new Point[] { leftDown, leftUp, middle });
            graph.FillPolygon(GameManager.Instance.GetBrushForColor(tile.TopColor), new Point[] { leftUp, rightUp, middle });
            graph.FillPolygon(GameManager.Instance.GetBrushForColor(tile.RightColor), new Point[] { rightUp, rightDown, middle });
            graph.FillPolygon(GameManager.Instance.GetBrushForColor(tile.BottomColor), new Point[] { rightDown, leftDown, middle });

            graph.DrawRectangle(Pens.White, posX, posY, size, size);
            graph.DrawRectangle(Pens.Gray, posX + 1, posY + 1, size - 2, size - 2);
            graph.DrawLines(Pens.DarkGray, new Point[] { leftUp, middle, rightUp, middle, rightDown, middle, leftDown, middle });
        }

        public static void DrawEmptyTile(Graphics graph, int posX, int posY, int size)
        {
            graph.DrawRectangle(Pens.Gray, posX + 1, posY + 1, size - 2, size - 2);
        }
    }
}
