using System;
using System.Collections.Generic;
using System.Text;

namespace Azbest
{
    public class RotatedTile : IDrawableSquare
    {
        public Tile BaseTile = null;

        public int Rotation = 0;

        public int LeftColor
        {
            get { return BaseTile.SideColors[(4 - Rotation) % 4]; }
        }

        public int TopColor
        {
            get { return BaseTile.SideColors[(5 - Rotation) % 4]; }
        }

        public int RightColor
        {
            get { return BaseTile.SideColors[(6 - Rotation) % 4]; }
        }

        public int BottomColor
        {
            get { return BaseTile.SideColors[(7 - Rotation) % 4]; }
        }

        public RotatedTile(Tile baseTile, int rotation)
        {
            BaseTile = baseTile;
            Rotation = rotation;
        }

        public string GetSidesString()
        {
            return LeftColor.ToString() + " " + TopColor.ToString() + " " + RightColor.ToString() + " " + BottomColor.ToString() + " ";
        }

        public void Rotate(int rightTurns)
        {
            if (rightTurns < 0)
            {
                rightTurns -= (((rightTurns) / 4) - 1);
            }

            Rotation += rightTurns;
            Rotation = Rotation % 4;
        }       

    }
}
