using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace Azbest
{
    public class RandomSolver
    {
        private CommunicationClient commClient = new CommunicationClient();

        public void Solve()
        {
            Random rand = new Random();
            bool success = false;
            
            while (!success)
            {
                try
                {
                    commClient.Connect();
                    success = true;
                }
                catch
                {
                    Console.WriteLine("Nie udao si poczy z serwerem. Prbuj dalej");
                    Thread.Sleep(3000);
                }
            }
            
            int boardSize = 1;
            while (boardSize * boardSize < commClient.Tiles.Length)
            {
                ++boardSize;
            }

            int[,] indices = new int[boardSize, boardSize];
            int[,] rotations = new int[boardSize, boardSize];
            
            for (int iY = 0; iY < boardSize; ++iY)
            {
                for (int iX = 0; iX < boardSize; ++iX)
                {
                    indices[iX, iY] = -1; // nie ma plytki
                    rotations[iX, iY] = 0;
                }
            }

            // ustawiamy plytki z przesunieciem
            
            for (int i = 0; i < boardSize * boardSize; ++i)
            {
                indices[i % boardSize, i / boardSize] = (i + 2) % (boardSize * boardSize);
                rotations[i % boardSize, i / boardSize] = 0;
                commClient.SetBoard(indices, rotations);                    
                Thread.Sleep(200);
            }

            //for (int iC = 0; iC < 1000; ++iC)
            {
                // obracamy plytki o jeden w lewo
                for (int i = 0; i < boardSize * boardSize; ++i)
                {
                    rotations[i % boardSize, i / boardSize] = (rotations[i % boardSize, i / boardSize] + 1) % 4;
                    commClient.SetBoard(indices, rotations);

                }
                Thread.Sleep(200);
            }
            commClient.Disconnect();

        }
    }
}
